// Copyright (c) 2018 LG Electronics, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

#ifndef WEBOSINPUTPANELLOCATOR_P_H
#define WEBOSINPUTPANELLOCATOR_P_H

#include <QObject>
#include <QRect>
#include <QHash>

class WebOSInputPanelLocator;

class WebOSInputPanelLocatorPrivate : public QObject {
    Q_OBJECT
    Q_DISABLE_COPY(WebOSInputPanelLocatorPrivate);
    Q_DECLARE_PUBLIC(WebOSInputPanelLocator);
public:
    WebOSInputPanelLocatorPrivate(WebOSInputPanelLocator* q);
    void setInputPanelRect(const QObject* focusObj, int32_t x, int32_t y, uint32_t width, uint32_t height);
    QRect inputPanelRect(const QObject* focusObj) const;
    void focusObjectDestroyed(QObject* focusObj);

    WebOSInputPanelLocator* q_ptr;

private:
    QHash<const QObject*, QRect> m_inputPanelRect;

};
#endif
